SuperStrict

Framework openb3d.B3dglgraphics
'Framework sidesign.minib3d

Import brl.tgaloader
Import brl.Map

Graphics3D(1024, 600)

Global cam:TCamera = CreateCamera()
Global BSP:TBSP = New TBSP

Print "Start: " + GCMemAlloced()

Local ms:Int = MilliSecs()

For Local i:Int = 1 To 100

	Print "Run #" + i
	BSP.AddAll
	BSP.DeleteAll

Next

Print MilliSecs() - ms
	
End

Type TBSP

	Field pivot:TPivot
	Field candle:TCandle
	
	Field candlemap:TMap
	Global candlelist:TList
		
	Method New()
		
		candlemap = CreateMap()
		candlelist = CreateList()
		
	End Method
	
	Method AddAll()
	
		Local num:Int = Rand(100, 1000)
	
		For Local i:Int = 1 To num
		
			BSP.AddCandle(i)
			
		Next
		
		GCCollect()
		Print "Created " + num + " Candles"': " + GCMemAlloced() + " Bytes used"
	
	End Method
	
	Method DeleteAll()
	
		Local num:Int
	
		For Local c:TCandle = EachIn candlelist
				
			DeleteCandle(c)
			num:+1
		
		Next

		GCCollect()
		Print "Deleted " + num + " Candles: " + GCMemAlloced() + " Bytes used"
			
	End Method
	
	Method AddCandle(id:Int)
	
		Local c:TCandle = New TCandle
		c.id = id
		c.ent = CreateSprite()
		c.tex = LoadTexture("candle.tga")
		c.x = Rnd(-100, 100)
		c.y = Rnd(-10, 10)
		c.z = Rnd(-100, 100)
		
		PositionEntity c.ent, c.x, c.y, c.z
		
		MapInsert(candlemap, String(c.id), c)
	
	End Method
	
	Method DeleteCandle(c:TCandle)
			
		MapRemove(candlemap, String(c.id))
		ListRemove(candlelist, c)
		
		c.ent.FreeEntity
		'Print "ENT OK: " + c.id

		c.tex.FreeTexture
		'Print "TEX OK: " + c.id

		c = Null
		
	End Method

End Type

Type TCandle
	
	Method New()
	
		ListAddLast(TBSP.candlelist, Self)
	
	End Method

	Field id:Int
	Field ent:TSprite
	Field tex:TTexture
	Field parent:TEntity
	Field child:TEntity
	Field x:Float
	Field y:Float
	Field z:Float

End Type